#ifndef INTERNAL_DEFS
#define INTERNAL_DEFS



#ifndef PI
#define PI 3.141592653589793238462643
#endif

#ifndef EPSILON
#define EPSILON 1e-15
#endif

#ifndef INFTY_D
#define INFTY_D numeric_limits<double>::infinity()
#endif

#ifndef NAN_D
#define NAN_D std::numeric_limits<double>::quiet_NaN()
#endif




#if defined(WIN32) || defined(_WIN32) || defined(__WIN32__) || defined(__TOS_WIN__)
	#ifndef IS_WINDOWS
		#define IS_WINDOWS
	#endif
	#include <direct.h>
	#include <shellapi.h>
#elif defined(unix) || defined(__unix) || defined(__unix__)
	#ifndef IS_UNIX
		#define IS_UNIX
	#endif
	#include <sys/types.h>
	#include <sys/stat.h>
	#include <unistd.h>
	#include <dirent.h>
#elif defined(__APPLE__)
	#ifndef IS_APPLE
		#define IS_APPLE
	#endif
	#include <unistd.h>
	#include <dirent.h>
#endif

#define DIRECTORY_SEPARATOR "/"


#endif